package actors

import (
	"xbus.io/go-xbus/v4"
)

// NullConsumer is a consumer that always ends with success without reading
// the input envelopes.
type NullConsumer struct{}

// NewNullConsumer is a NullConsumer factory.
func NewNullConsumer(*xbus.Actor, xbus.Settings) (xbus.ActorService, error) {
	return &NullConsumer{}, nil
}

// Process handles an incoming process.
func (c *NullConsumer) Process(apc *xbus.ActorProcessingContext) error {
	return nil
}

func init() { //nolint:gochecknoinits
	xbus.RegisterActorService("stdlib.nullconsumer", NewNullConsumer)
}
