package routing

import (
	"testing"

	"github.com/stretchr/testify/assert"
	"orus.io/xbus/xbus-stdlib/service"
	"orus.io/xbus/xbus-stdlib/service/svctest"
	"xbus.io/go-xbus/v4/api"
	"xbus.io/go-xbus/v4/envelope"
)

func TestImperativeRouter(t *testing.T) {
	tester := svctest.TestWorker(t, NewImperativeRouterAsActorService,
		&api.Actor{Name: "bob"}, service.Settings{"extract-output-jq": ".output"},
	)

	e := envelope.MustNewEnvelope(
		envelope.MustNewTextMessage("msg", `{"output":"out1"}`))

	outputs, err := tester.Run(svctest.Inputs{api.DefaultInput: e})

	assert.NoError(t, err)

	assert.Equal(t, 1, len(outputs.Forwarded))
	assert.Equal(t, 0, len(outputs.Sent))

	if assert.Contains(t, outputs.Forwarded, "out1") {
		assert.Equal(t, e.ID(), outputs.Forwarded["out1"])
	}
}
