package svctest

import (
	"xbus.io/go-xbus/v4/api"
	"xbus.io/go-xbus/v4/envelope"
)

// NewOutputs creates a testing-purpose service.Output implementation
func NewOutputs() *Outputs {
	return &Outputs{
		Forwarded: make(map[string]api.UUID),
		Sent:      make(map[string]envelope.Envelope),
	}
}

// Outputs holds the envelopes emitter by a worker
type Outputs struct {
	Forwarded map[string]api.UUID
	Sent      map[string]envelope.Envelope
}

// Forward an envelope on a given output
func (outputs *Outputs) Forward(output string, id api.UUID) error {
	outputs.Forwarded[output] = id
	return nil
}

// Send an envelope on a given output
func (outputs *Outputs) Send(output string, env envelope.Envelope) error {
	outputs.Sent[output] = env
	return nil
}
